#include"verticals.h"
#include<iostream.h>
#include<string.h>


char* Verticals::create(Reader myReader, Table myTable){

    set_options(myReader);
    int form=myReader.get_form();
    int trans=myReader.get_vert_trans();

    set_filename(myReader.get_dir_head());
    set_title(myReader.get_title());
    set_head(trans);
    set_form(form);
    set_Basic_Row(myTable.getForms(form).get_itsSeira(trans));

    list_intervals();
    num_intervals();
    series_list();
    two_columns(myTable.getForms(myReader.get_form()));
    accords(myTable.getForms(myReader.get_form()));
    smooth_climax();
    smooth_climax();
    print_settings();
    print_score(1);
    print_barline();
    print_score(2);
    end_block();
    print_h_settings();
    print_v_accords('a');
    paravan();
    print_v_accords('b');
    the_end();
    return file_head;
}

Verticals::Verticals(){
    for(int i=0; i<5; i++){
	chordsA[i].setPlithos(6);
	chordsB[i].setPlithos(6);
	Hex_a[i].setPlithos(6);
	Hex_b[i].setPlithos(6);
    }
    texfile=new ofstream;
}

Verticals::~Verticals(){
  //  delete texfile;
}

void Verticals::set_options(Reader myReader){
    end=myReader.get_opt(0);
}

void Verticals::set_title(char *titel){
  title=titel;
}

void Verticals::set_filename(const char* name){
  strcpy(filename, name);
  strcpy(file_head, name);
  strcat(filename, "_vert.tex");
  strcat(file_head, "_vert");
}

void Verticals::set_head(int x){
  head=x;
}

void Verticals::set_form(int x){
  char *forms[]={"P", "R", "I", "RI"};
  form=forms[x];
}

void Verticals::set_Basic_Row(Row Basic){
  Basic_Row=Basic;
}

Row* Verticals::get_hexachords(char type){
  if(type=='a') return Hex_a;
  else return Hex_b;
}

int Verticals::get_head(void){
  return head;
}

int* Verticals::getList(char type){
  if(type=='a') return listA;
  else return listB;
}

Row* Verticals::get_chords(char type){
  if(type=='a') return chordsA;
  else return chordsB;
}


Row Verticals::get_basic_row(void){
  return Basic_Row;
}

void Verticals::list_intervals(void){
  int i;
  Interval Diastima[12];

  /* 1st hexachord */
  for(i=0; i<5; i++)
    Basic_Row.recognize(
	Basic_Row.getNotes(0), Basic_Row.getNotes(i+1), Diastima[i]);

  /* 2nd hexachord */
  for(i=5; i<10; i++)
    Basic_Row.recognize(
	Basic_Row.getNotes(6), Basic_Row.getNotes(i+2), Diastima[i]);

  /* Check results */
  cout << "\nThe intervals are: ";
  for(i=0; i<10; i++){
    cout << Diastima[i].get_space() << Diastima[i].get_type() << " ";
    if(i==4) cout << "** ";
  }
  cout << endl;
}

int Verticals::num_intervals(void){
  int i, number;

  /* 1st Hexachord */
  for(i=0; i<5; i++)
    numInt[i]=Basic_Row.chr_interval(Basic_Row.getNotes(0), Basic_Row.getNotes(i+1));

  /* 2nd hexachord */
  for(i=5; i<10; i++)
    numInt[i]=Basic_Row.chr_interval(Basic_Row.getNotes(6), Basic_Row.getNotes(i+2));

  /* Check results */
  cout << "\nThe intervals are: ";
  for(i=0; i<10; i++){
    cout << numInt[i] << " ";
    if(i==4) cout << "** ";
  }
  cout << endl;
    return 1;
}

//   FUNCTION: it creates a row with the initial tones of the row
//   forms which shall be used.
void Verticals::series_list(void){
  int i;

  /* 1st hexachord */
  for(i=0; i<5; i++) listA[i]=((head-numInt[i]+24)%12);
  for(i=5; i<10; i++) listB[i-5]=((head-numInt[i]+24)%12);

  /* Print results */
  cout << "The forms of the series are: ";
  for(i=0; i<5; i++) cout << listA[i] << " ";
  cout << " ** ";
  for(i=0; i<5; i++) cout << listB[i] << " ";
  cout << endl;
}

// FUNCTION: it creates the two columns of the big table (the 10 (5+5)
// rotated hexachords a and b).
void Verticals::two_columns(Matrix myMatrix){
  int i, j, posA, posB;

  for(i=0; i<5; i++){
      posA=listA[i];
      posB=listB[i];
      for(j=0; j<6; j++){
	  Hex_a[i].setNotes(
	      j, myMatrix.get_itsSeira(posA).getNotes((j+i+7)%6));
	  Hex_b[i].setNotes(
	      j, myMatrix.get_itsSeira(posB).getNotes((j+i+7)%6+6));
      }
  }
}

void Verticals::accords(Matrix myMatrix){
  int i, j;

  // Initialize the first note (0) of the vertical-columns.
  for(i=0; i<5; i++){
      chordsA[i].setNotes(0, myMatrix.get_itsSeira(head).getNotes(i+1));
      chordsB[i].setNotes(0, myMatrix.get_itsSeira(head).getNotes(i+7));
    }
  // Initialize the rest 5 notes (1-5) of the vertical-columns.
  for(i=1; i<6; i++){
    for(j=1; j<6; j++){
	chordsA[i-1].setNotes(j, Hex_a[j-1].getNotes(i));
	chordsB[i-1].setNotes(j, Hex_b[j-1].getNotes(i));
      }
  }
}

// 2 TIMES!!!
void Verticals::smooth_climax(void){
  for(int i=0; i<5; i++){
    chordsA[i].smooth(chordsA[i].getNotes(0));
    chordsB[i].smooth(chordsB[i].getNotes(0));
    chordsA[i].climax();
    chordsB[i].climax();
  }
}

void Verticals::print_settings(void){
  int i, j;
  texfile->open(filename);

  *texfile << "\
\\input musixtex
\\input musixbar

\\indivbarrules
\\sepbarrule6
\\nostartrule
\\font\\bigrm = cmr10 scaled \\magstep 3
\\def\\putV#1{\\zcharnote{r}{\\loffset{0.5}{V$_{#1}$}}}
\\def\\put#1#2#3{\\zcharnote{12}{\\loffset{0.5}{{#1}$_{#3}$--{#2}}}}
\\def\\numbone#1{\\zcharnote{-6}{\\smalltype #1}}
\\def\\numbtwo#1{\\zcharnote{-6}{\\loffset{0.5}{\\smalltype #1}}}";

  *texfile << "\
\\instrumentnumber{6}";
//\\voffset -1.25in

  for(i=0; i<6; i++)
    *texfile << "\\setname{" << i << "}{" << 6-i << "}" << endl;

  *texfile << "\
\\setname{6}{Prime}
\\nobarnumbers
\\nopagenumbers
\\nostartrule
\\parindent 30pt
\\bigaccid\
";
  *texfile << "\\centerline{\\BIgtype " << title << "}" << endl;
  *texfile << "\
\\vskip 30pt
\\interinstrument = 20 pt
\\let\\extractline\\centerline
\\startextract\
";
  texfile->close();
}

void Verticals::print_score(int hexachord){
  // Base
  char hex[]={'a', 'b'};
  hexachord--;
  int i, j;
  texfile->open(filename, ios::app);
  *texfile << "\\NOtes\%" << endl;
  for(j=0; j<5; j++){
    *texfile <<
      "\\put{" << form << "}{" << hex[hexachord] << "}{" <<
      getList(hex[hexachord])[4-j] << "}\%" << endl;
    for(i=0; i<6; i++){
      *texfile << "\\numbone{" << (i+5-j)%6+1+hexachord*6 << "}";
      *texfile << "\\nq{";
      *texfile <<
	num2accid(get_hexachords(hex[hexachord])[4-j].getNotes(i).getAccid());
      *texfile <<
	num2notename(get_hexachords(hex[hexachord])[4-j].getNotes(i).getHead());
      *texfile << "}%" << endl;
    }
    *texfile << "&\%" << endl;
  }

  *texfile << "\\zcharnote{22}{\\bigrm " << form << "$_{";
  *texfile << get_head();
  *texfile << "}$--" << hex[hexachord] << "}%" << endl;

  for(i=0; i<6; i++){
    *texfile <<
      "\\putV " << i << "\\numbone{" << i+1+hexachord*6 << "}" <<
      "\\nq{" <<
      num2accid(get_basic_row().getNotes(i+hexachord*6).getAccid()) <<
      num2notename(get_basic_row().getNotes(i+hexachord*6).getHead()) <<
      "}\%" << endl;
  }
  *texfile << "\\en" << endl;
  texfile->close();
}

void Verticals::print_barline(void){
  texfile->open(filename, ios::app);
  *texfile << "\\bar" << endl;
  texfile->close();
}

void Verticals::end_block(void){
  texfile->open(filename, ios::app);
  *texfile << "\
\\conbarrule6
\\endextract

";
  texfile->close();
}

void Verticals::print_h_settings(void){
  texfile->open(filename, ios::app);
  *texfile << "\
\\vskip 30pt
\\instrumentnumber5
";

  for(int i=0; i<5; i++)
    *texfile << "\\setname{" << 5-i << "}{V$_" << i+1 << "$}" << endl;

  *texfile << "\
\\nobarnumbers
\\nopagenumbers
\\nostartrule
\\parindent 30pt
\\bigaccid

\\interinstrument = 0 pt
\\hsize=170mm
\\let\\extractline\\hbox
\\hbox to \\hsize{
";
  texfile->close();
}

void Verticals::print_v_accords(char hex){
  int i, j;
  texfile->open(filename, ios::app);

  *texfile << "\\startextract" << endl;
  *texfile << "\\NOtes\%" << endl;

  for(i=0; i<5; i++){
    *texfile << "\\nq{";
    for(j=0; j<6; j++)
      *texfile <<
	num2accid(get_chords(hex)[4-i].getNotes(j).getAccid()) <<
	num2notename(get_chords(hex)[4-i].getNotes(j).getHead());
    if(i<4) *texfile << "}&\%" << endl;
    else *texfile << "}\%" << endl;
    if(i==3) *texfile <<
	       "\\Uptext{\\sk\\sk\\hsk\\Bigtype " << hex << "}%" << endl;

  }

  *texfile << "\\en" << endl;
  *texfile << "\\endextract" << endl;
  texfile->close();
}

void Verticals::paravan(void){
  texfile->open(filename, ios::app);
  *texfile << "\\hskip 80pt" << endl;
  texfile->close();
}

void Verticals::the_end(void){
  texfile->open(filename, ios::app);
  *texfile << "}" << endl;
  *texfile << "\\hsize=190mm" << endl;
  if(end) *texfile << "\\end" << endl;
  texfile->close();
  cout << "Output is written on " << filename << endl;
}

char Verticals::num2accid(int x){
  char accid[]={'<', '_', '=', '^', '>'};
  return(accid[x+2]);
}

char Verticals::num2notename(int x){
  char heads[]={
    'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N',
    'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
    'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'};
  return(heads[x-5]);
}
